import { ConnectionBackend } from '@angular/http';
import { Injectable } from '@angular/core';
import { NativeHttpBackendD } from './native-http-backend';
import { checkAvailability } from '@ionic-native/core';
/**
 * @deprecated and will be gone. Use NativeHttpFallback instead
 */
var NativeHttpFallbackD = /** @class */ (function () {
    function NativeHttpFallbackD(nativeHttpBackend, fallback) {
        this.nativeHttpBackend = nativeHttpBackend;
        this.fallback = fallback;
        this.nativeIsForced = null;
        this.nativeIsAvailable = null;
    }
    NativeHttpFallbackD.prototype.createConnection = function (request) {
        /**
         * Native HTTP Cordova plugin doesn't like local requests
         */
        var isOutgoingRequest = /^(http|https):\/\//.test(request.url);
        if (isOutgoingRequest && this.isNativeHttpAvailable()) {
            return this.nativeHttpBackend.createConnection(request);
        }
        else {
            return this.fallback.createConnection(request);
        }
    };
    /**
     * Enable/disable forced native HTTP usage without preliminary check. Helpful for unit testing
     *
     * @param {boolean} isEnabled
     */
    NativeHttpFallbackD.prototype.forceNative = function (isEnabled) {
        this.nativeIsForced = isEnabled;
    };
    NativeHttpFallbackD.prototype.isNativeHttpAvailable = function () {
        if (this.nativeIsForced !== null) {
            return this.nativeIsForced;
        }
        if (this.nativeIsAvailable === null) {
            this.nativeIsAvailable =
                checkAvailability('cordova.plugin.http') === true;
        }
        return this.nativeIsAvailable;
    };
    NativeHttpFallbackD.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    NativeHttpFallbackD.ctorParameters = function () { return [
        { type: NativeHttpBackendD, },
        { type: ConnectionBackend, },
    ]; };
    return NativeHttpFallbackD;
}());
export { NativeHttpFallbackD };
//# sourceMappingURL=native-http-fallback.js.map